//
//  UILinedTextView.m
//  smileme
//
//  Created by Илья Семенов on 19.04.13.
//  Copyright (c) 2013 Digital Bar. All rights reserved.
//

#import "UILinedTextView.h"

@implementation UILinedTextView

-(id)init
{
    self = [super init];
    if(self)
    {
        self.alwaysBounceVertical = YES;
    }
    return self;
}

- (void)drawRect:(CGRect)rect {
    CGContextRef context = UIGraphicsGetCurrentContext();
    CGContextSetStrokeColorWithColor(context, [UIColor lightGrayColor].CGColor);
    CGContextSetLineWidth(context, 1.0f);
    CGContextBeginPath(context);
    NSUInteger numberOfLines = (self.contentSize.height + self.bounds.size.height) / self.font.leading+1;
    CGFloat baselineOffset = 7.5f;
    for (int x = 0; x < numberOfLines; x++) {
        CGContextMoveToPoint(context, self.bounds.origin.x, self.font.leading*x + baselineOffset);
        CGContextAddLineToPoint(context, self.bounds.size.width, self.font.leading*x + baselineOffset);
    }
    
    CGContextClosePath(context);
    CGContextStrokePath(context);
}

@end
