//
//  VkontakteLoginViewController.m
//  smileme
//
//  Created by Илья Семенов on 19.04.13.
//  Copyright (c) 2013 Digital Bar. All rights reserved.
//

#import "VkontakteLoginViewController.h"

@interface VkontakteLoginViewController ()

@end

@implementation VkontakteLoginViewController

- (void)viewDidLoad
{
    //Put your app credentials here (you can get it at http://vk.com/editapp?act=create
    
    self.appID = vk_app_id;
    self.appToken = vk_app_token;
    self.appPermissions = @"photos, wall";
    
    [super viewDidLoad];
    self.webView = [[UIWebView alloc] init];
    self.webView.delegate = self;    
    [self.view addSubview:self.webView];
    
    NSString *authLink = [[NSString stringWithFormat:@"https://api.vk.com/oauth/authorize?client_id=%@&scope=%@&redirect_uri=http://api.vk.com/blank.html&display=touch&response_type=token", self.appID, self.appPermissions] stringByAddingPercentEscapesUsingEncoding:NSUTF8StringEncoding];
    
    NSURLRequest* req = [NSURLRequest requestWithURL:[NSURL URLWithString:authLink] cachePolicy:NSURLRequestReloadIgnoringCacheData timeoutInterval:15];
    [self.webView loadRequest:req];
}

-(void)webViewDidFinishLoad:(UIWebView *)webView {
    // Если есть токен сохраняем его
    if ([self.webView.request.URL.absoluteString rangeOfString:@"access_token"].location != NSNotFound) {
        NSString *accessToken = [self stringBetweenString:@"access_token="
                                                andString:@"&"
                                              innerString:[[[webView request] URL] absoluteString]];
        
        NSArray *userAr = [[[[webView request] URL] absoluteString] componentsSeparatedByString:@"&user_id="];
        NSString *user_id = [userAr lastObject];
        NSLog(@"User id: %@", user_id);
        if(user_id){
            [[NSUserDefaults standardUserDefaults] setObject:user_id forKey:@"VKAccessUserId"];
        }
        
        if(accessToken){
            [[NSUserDefaults standardUserDefaults] setObject:accessToken forKey:@"VKAccessToken"];
            [[NSUserDefaults standardUserDefaults] setObject:[NSDate date] forKey:@"VKAccessTokenDate"];
            [[NSUserDefaults standardUserDefaults] synchronize];
        }
        
        NSLog(@"vkWebView response: %@",[[[webView request] URL] absoluteString]);
        [self.webView loadHTMLString:@"" baseURL:nil];
        [self dismissViewControllerAnimated:YES completion:nil];
    } else if ([self.webView.request.URL.absoluteString rangeOfString:@"error"].location != NSNotFound) {
        NSLog(@"Error: %@", self.webView.request.URL.absoluteString);
        [self.webView loadHTMLString:@"" baseURL:nil];
        [self dismissViewControllerAnimated:YES completion:nil];
    }
    
}
- (NSString*)stringBetweenString:(NSString*)start
                       andString:(NSString*)end
                     innerString:(NSString*)str
{
    NSScanner* scanner = [NSScanner scannerWithString:str];
    [scanner setCharactersToBeSkipped:nil];
    [scanner scanUpToString:start intoString:NULL];
    if ([scanner scanString:start intoString:NULL]) {
        NSString* result = nil;
        if ([scanner scanUpToString:end intoString:&result]) {
            return result;
        }
    }
    return nil;
}

-(void)viewDidLayoutSubviews
{
    [super viewDidLayoutSubviews];
    self.webView.frame = CGRectMake(0, 0, self.view.frame.size.width, self.view.frame.size.height);
}
-(void)webView:(UIWebView *)webView didFailLoadWithError:(NSError *)error
{
    NSLog(@"%@", error.localizedDescription);
    [self dismissViewControllerAnimated:YES completion:nil];
}
- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

@end
