
//  VkontakteShareController.m
//  smileme
//
//  Created by Илья Семенов on 19.04.13.
//  Copyright (c) 2013 Digital Bar. All rights reserved.
//

#import "VkontakteShareController.h"
#import <QuartzCore/QuartzCore.h>
#import "VkontakteLoginViewController.h"
#import "MBProgressHUD.h"
@interface VkontakteShareController ()
{
    BOOL _hasCaptcha;
    BOOL _shouldCleanCaptured;
    MBProgressHUD* _hud;
}

@end

@implementation VkontakteShareController

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization
        self.shareImages = [NSMutableArray new];
    }
    return self;
}

- (void)viewDidLoad
{
    _hasCaptcha = NO;
    _shouldCleanCaptured = YES;
    [super viewDidLoad];
    self.view.backgroundColor = [UIColor clearColor];
    self.backgroundView = [[UIImageView alloc] init];
    self.overlayView = [[UIImageView alloc] initWithImage:[UIImage imageNamed:@"vksharer_shadowlayer.png"]];
    self.overlayView.contentMode = UIViewContentModeScaleToFill;
    self.overlayView.alpha = 0.0;
    self.postView = [[UIView alloc] init];
    self.postView.backgroundColor = [UIColor whiteColor];
    self.postView.layer.cornerRadius = 10;
    self.postView.clipsToBounds = YES;
    
    self.containerView = [[UIView alloc] init];
    self.containerView.backgroundColor = [UIColor clearColor];
    self.containerView.layer.shadowColor = [UIColor blackColor].CGColor;
    self.containerView.layer.shadowRadius = 20;
    self.containerView.layer.shadowOpacity = 0.8;
    
    self.textView = [[UILinedTextView alloc] init];
    self.textView.delegate = self;
    self.textView.font = [UIFont systemFontOfSize:18];
    
    self.toolBar = [[UIToolbar alloc] init];
    self.cancelButton = [[UIBarButtonItem alloc] initWithTitle:@"Cancel" style:UIBarButtonItemStyleBordered target:self action:@selector(cancel)];
    UIBarButtonItem* flexibleSpace0 = [[UIBarButtonItem alloc] initWithBarButtonSystemItem:UIBarButtonSystemItemFlexibleSpace target:nil action:nil];
    UILabel* vkLabel = [[UILabel alloc] init];
    vkLabel.text = @"Vkontakte";
    vkLabel.font = [UIFont boldSystemFontOfSize:20];
    vkLabel.textColor = [UIColor whiteColor];
    vkLabel.shadowColor   = [UIColor darkGrayColor];
    vkLabel.shadowOffset  = CGSizeMake(-1.0,-1.0);
    
    vkLabel.backgroundColor = [UIColor clearColor];
    [vkLabel sizeToFit];
    
    UIBarButtonItem* labelBarItem = [[UIBarButtonItem alloc] initWithCustomView:vkLabel];
    UIBarButtonItem* flexibleSpace1 = [[UIBarButtonItem alloc] initWithBarButtonSystemItem:UIBarButtonSystemItemFlexibleSpace target:nil action:nil];
    self.postButton = [[UIBarButtonItem alloc] initWithTitle:@"Post" style:UIBarButtonItemStyleBordered target:self action:@selector(postButtonTapped)];
    [self.toolBar setItems:@[self.cancelButton, flexibleSpace0, labelBarItem, flexibleSpace1, self.postButton]];
        
    
    //self.toolBar.tintColor = [UIColor cyanColor];
    
    
    [self.view addSubview:self.backgroundView];
    
    
    UIWindow* window = [UIApplication sharedApplication].keyWindow;
    if (!window) {
        window = [[UIApplication sharedApplication].windows objectAtIndex:0];
    }
    UIView* topView = [[window subviews] lastObject];
    [topView addSubview:self.overlayView];
    //[topView bringSubviewToFront:self.containerView];
    //[rootView addSubview:self.overlayView];
    self.overlayView.frame = CGRectMake(0, 0, self.overlayView.superview.frame.size.width, self.overlayView.superview.frame.size.height);    
    
    [self.view addSubview:self.containerView];
    [self.containerView addSubview:self.postView];
    [self.postView addSubview:self.textView];
    [self.postView addSubview:self.toolBar];
}

-(void)viewWillAppear:(BOOL)animated
{
    [super viewWillAppear:animated];
    
    if(_shouldCleanCaptured)
    {
        UIWindow *keyWindow = [[UIApplication sharedApplication] keyWindow];
        CGRect rect = [keyWindow bounds];
        UIGraphicsBeginImageContextWithOptions(rect.size,YES,0.0f);
        CGContextRef context = UIGraphicsGetCurrentContext();
        [keyWindow.layer renderInContext:context];
        self.capturedImage = UIGraphicsGetImageFromCurrentImageContext();
        UIGraphicsEndImageContext();
        
        [UIView animateWithDuration:0.5 animations:^{
            self.overlayView.alpha = 1;
        }];
    }
    _hud.removeFromSuperViewOnHide = YES;
    [_hud hide:YES afterDelay:0.0];
    [self.textView becomeFirstResponder];
        
}
-(void)viewDidAppear:(BOOL)animated
{
    [super viewDidAppear:animated];
    self.backgroundView.image = self.capturedImage;
    _shouldCleanCaptured = YES;
    
    [self.overlayView removeFromSuperview];
    [self.backgroundView addSubview:self.overlayView];
}
-(void)viewWillDisappear:(BOOL)animated
{
    [super viewWillDisappear:animated];
    if(_shouldCleanCaptured)
    {
        _shouldCleanCaptured = NO;
        self.backgroundView.alpha = 0;
        [self.overlayView removeFromSuperview];
        UIWindow* window = [UIApplication sharedApplication].keyWindow;
        if (!window) {
            window = [[UIApplication sharedApplication].windows objectAtIndex:0];
        }
        UIView* topView = [[window subviews] lastObject];
        [topView addSubview:self.overlayView];
        
        [UIView animateWithDuration:0.5 animations:^{
            self.overlayView.alpha = 0;
        } completion:^(BOOL finished) {
            [self.overlayView removeFromSuperview];
        }];
    }
}
-(void)viewDidLayoutSubviews
{
    CGFloat height = [[UIScreen mainScreen] bounds].size.height;
    self.view.frame = CGRectMake(0, 0, self.presentingViewController.view.frame.size.width, height);
    [super viewDidLayoutSubviews];    
    self.containerView.frame = CGRectMake(5, 40, 310, 200);
    self.postView.frame = CGRectMake(0, 0, 310, 200);
    self.backgroundView.frame = CGRectMake(0, 0, self.view.frame.size.width, self.view.frame.size.height);
    self.toolBar.frame = CGRectMake(0, -1, 310, 44);
    self.textView.frame = CGRectMake(0, 44, 310, 125);
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
}

-(void)cancel
{
    _hud.removeFromSuperViewOnHide = YES;
    [_hud hide:YES afterDelay:1.0];
    [self dismissViewControllerAnimated:YES completion:nil];
}
-(void)postButtonTapped
{
    if(self.textView.text.length==0 && self.shareImages.count==0 && !self.shareLink)
    {
        _hud = [MBProgressHUD showHUDAddedTo:self.containerView animated:YES];
        _hud.mode = MBProgressHUDModeText;
        _hud.labelText = @"Пустовато :(";
        _hud.removeFromSuperViewOnHide = YES;
        [_hud hide:YES afterDelay:1.0];
        return;
    }
    _hud = [MBProgressHUD showHUDAddedTo:self.containerView animated:YES];
    _hud.mode = MBProgressHUDModeIndeterminate;
    if(self.shareImages.count>0)
    {
        dispatch_async(dispatch_get_main_queue(), ^{
            [self postPhoto];
        });
    }
    else
    {
        dispatch_async(dispatch_get_main_queue(), ^{
            [self post];
        });
    }
}
-(void)post {
    
    NSString *user_id = [[NSUserDefaults standardUserDefaults] objectForKey:@"VKAccessUserId"];
    NSString *accessToken = [[NSUserDefaults standardUserDefaults] objectForKey:@"VKAccessToken"];
    if(!user_id || !accessToken)
    {
        NSHTTPCookieStorage *storage = [NSHTTPCookieStorage sharedHTTPCookieStorage];
        NSHTTPCookie *cookie;
        for (cookie in [storage cookies])
        {
            
            NSString* domainName = [cookie domain];
            NSRange domainRange = [domainName rangeOfString:@"vk.com"];
            
            if(domainRange.length > 0) {
                [storage deleteCookie:cookie];
            }
        }
        VkontakteLoginViewController* loginView = [[VkontakteLoginViewController alloc] init];
        _shouldCleanCaptured = NO;
        [self presentViewController:loginView animated:YES completion:nil];
    }
    else
    {
        NSString *errorMsg = [self postLink];
        if(!errorMsg)
            [self cancel];
        else
        {
            NSHTTPCookieStorage *storage = [NSHTTPCookieStorage sharedHTTPCookieStorage];
            NSHTTPCookie *cookie;
            for (cookie in [storage cookies])
            {
                
                NSString* domainName = [cookie domain];
                NSRange domainRange = [domainName rangeOfString:@"vk.com"];
                
                if(domainRange.length > 0) {
                    [storage deleteCookie:cookie];
                }
            }
            VkontakteLoginViewController* loginView = [[VkontakteLoginViewController alloc] init];
            _shouldCleanCaptured = NO;
            [self presentViewController:loginView animated:YES completion:nil];
        }
        
    }
}

- (NSString*)postPhoto
{
    
    NSString *user_id = [[NSUserDefaults standardUserDefaults] objectForKey:@"VKAccessUserId"];
    NSString *accessToken = [[NSUserDefaults standardUserDefaults] objectForKey:@"VKAccessToken"];
    if(!user_id || !accessToken)
    {
        NSHTTPCookieStorage *storage = [NSHTTPCookieStorage sharedHTTPCookieStorage];
        NSHTTPCookie *cookie;
        for (cookie in [storage cookies])
        {
            
            NSString* domainName = [cookie domain];
            NSRange domainRange = [domainName rangeOfString:@"vk.com"];
            
            if(domainRange.length > 0) {
                [storage deleteCookie:cookie];
            }
        }
        VkontakteLoginViewController* loginView = [[VkontakteLoginViewController alloc] init];
        _shouldCleanCaptured = NO;
        [self presentViewController:loginView animated:YES completion:nil];
        return nil;
    }
    else
    {
    
        NSString *text = self.textView.text;
        NSMutableString* attachments = [NSMutableString new];
        NSString* photoIDs = [self makePhotoAttachments];
        [attachments appendString:photoIDs];
        if(self.shareLink)
        {
            [attachments appendFormat:@",%@", self.shareLink];
        }
        NSString *postToWallLink = [NSString stringWithFormat:@"https://api.vk.com/method/wall.post?owner_id=%@&access_token=%@&message=%@&attachment=%@", user_id, accessToken, text, attachments];
        NSDictionary *postToWallDict = [self sendRequest:postToWallLink withCaptcha:NO];
        NSString *errorMsg = [[postToWallDict  objectForKey:@"error"] objectForKey:@"error_msg"];
        if(!errorMsg)
        {
            [self cancel];
        }
        return errorMsg;
    }
}
- (NSString*)makePhotoAttachments
{
    NSString *user_id = [[NSUserDefaults standardUserDefaults] objectForKey:@"VKAccessUserId"];
    NSString *accessToken = [[NSUserDefaults standardUserDefaults] objectForKey:@"VKAccessToken"];    
    int counter = 0;
    NSMutableString* result = [NSMutableString new];
    for(UIImage* image in self.shareImages)
    {
        NSString *getWallUploadServer = [NSString stringWithFormat:@"https://api.vk.com/method/photos.getWallUploadServer?owner_id=%@&access_token=%@", user_id, accessToken];
        NSDictionary *uploadServer = [self sendRequest:getWallUploadServer withCaptcha:NO];
        NSString *upload_url = [[uploadServer objectForKey:@"response"] objectForKey:@"upload_url"];
        NSData *imageData = UIImageJPEGRepresentation(image, 1.0f);
        
        NSDictionary *postDictionary = [self sendPOSTRequest:upload_url withImageData:imageData];
        
        // Из полученного ответа берем hash, photo, server
        NSString *hash = [postDictionary objectForKey:@"hash"];
        NSString *photo = [postDictionary objectForKey:@"photo"];
        NSString *server = [postDictionary objectForKey:@"server"];
        NSString *saveWallPhoto = [NSString stringWithFormat:@"https://api.vk.com/method/photos.saveWallPhoto?owner_id=%@&access_token=%@&server=%@&photo=%@&hash=%@", user_id, accessToken,server,photo,hash];
        NSDictionary *saveWallPhotoDict = [self sendRequest:saveWallPhoto withCaptcha:NO];
        
        NSDictionary *photoDict = [[saveWallPhotoDict objectForKey:@"response"] lastObject];
        NSString *photoId = [photoDict objectForKey:@"id"];
        [result appendString:photoId];
        counter++;
        if(counter!=self.shareImages.count)
        {
            [result appendString:@","];
        }
    }
    return result;
}
- (NSString*)postLink
{
    NSString *user_id = [[NSUserDefaults standardUserDefaults] objectForKey:@"VKAccessUserId"];
    NSString *accessToken = [[NSUserDefaults standardUserDefaults] objectForKey:@"VKAccessToken"];
    NSString *text = self.textView.text;
    NSString *postToWallLink = [NSString stringWithFormat:@"https://api.vk.com/method/wall.post?owner_id=%@&access_token=%@&message=%@&attachment=%@", user_id, accessToken, text, self.shareLink];
    NSDictionary *postToWallDict = [self sendRequest:postToWallLink withCaptcha:NO];
    NSString *errorMsg = [[postToWallDict  objectForKey:@"error"] objectForKey:@"error_msg"];
    return errorMsg;
    
}
- (NSDictionary *) sendPOSTRequest:(NSString *)reqURl withImageData:(NSData *)imageData {
    NSLog(@"Sending request: %@", reqURl);
    
    NSMutableURLRequest *request = [NSMutableURLRequest requestWithURL:[NSURL URLWithString:reqURl]
                                                           cachePolicy:NSURLRequestReloadIgnoringLocalCacheData
                                                       timeoutInterval:60.0];
    // Устанавливаем метод POST
    [request setHTTPMethod:@"POST"];
    
    // Кодировка UTF-8
    [request addValue:@"8bit" forHTTPHeaderField:@"Content-Transfer-Encoding"];
    
    CFUUIDRef uuid = CFUUIDCreate(nil);
    NSString *uuidString = (NSString*)CFBridgingRelease(CFUUIDCreateString(nil, uuid));
    CFRelease(uuid);
    NSString *stringBoundary = [NSString stringWithFormat:@"0xKhTmLbOuNdArY-%@",uuidString];
    NSString *endItemBoundary = [NSString stringWithFormat:@"\r\n--%@\r\n",stringBoundary];
    
    NSString *contentType = [NSString stringWithFormat:@"multipart/form-data;  boundary=%@", stringBoundary];
    
    [request setValue:contentType forHTTPHeaderField:@"Content-Type"];
    
    NSMutableData *body = [NSMutableData data];
    
    [body appendData:[[NSString stringWithFormat:@"--%@\r\n",stringBoundary] dataUsingEncoding:NSUTF8StringEncoding]];
    [body appendData:[@"Content-Disposition: form-data; name=\"photo\"; filename=\"photo.jpg\"\r\n" dataUsingEncoding:NSUTF8StringEncoding]];
    [body appendData:[@"Content-Type: image/jpg\r\n\r\n" dataUsingEncoding:NSUTF8StringEncoding]];
    [body appendData:imageData];
    [body appendData:[[NSString stringWithFormat:@"%@",endItemBoundary] dataUsingEncoding:NSUTF8StringEncoding]];
    
    [request setHTTPBody:body];
    
    NSData *responseData = [NSURLConnection sendSynchronousRequest:request returningResponse:nil error:nil];
    NSDictionary *dict;
    if(responseData){
        NSError* error;
        dict = [NSJSONSerialization JSONObjectWithData:responseData options:NSJSONReadingAllowFragments error:&error];
        
        NSString *errorMsg = [[dict objectForKey:@"error"] objectForKey:@"error_msg"];
        
        NSLog(@"Server response: %@ \nError: %@", dict, errorMsg);
        
        return dict;
    }
    return nil;
}
- (NSDictionary *) sendRequest:(NSString *)reqURl withCaptcha:(BOOL)captcha {
    // Если это запрос после ввода капчи, то добавляем в запрос параметры captcha_sid и captcha_key
    if(captcha == YES){
        NSString *captcha_sid = [[NSUserDefaults standardUserDefaults] objectForKey:@"captcha_sid"];
        NSString *captcha_user = [[NSUserDefaults standardUserDefaults] objectForKey:@"captcha_user"];
        // Добавляем к запросу данные для капчи. Не забываем, что введенный пользователем текст нужно обработать.
        reqURl = [reqURl stringByAppendingFormat:@"&captcha_sid=%@&captcha_key=%@", captcha_sid, [captcha_user stringByReplacingPercentEscapesUsingEncoding:NSUTF8StringEncoding]];
    }
    reqURl = [reqURl stringByAddingPercentEscapesUsingEncoding:NSUTF8StringEncoding];
    NSLog(@"Sending request: %@", reqURl);
    NSMutableURLRequest *request = [NSMutableURLRequest requestWithURL:[NSURL URLWithString:reqURl]
                                                           cachePolicy:NSURLRequestReloadIgnoringLocalCacheData
                                                       timeoutInterval:10.0];
    
    
    // Для простоты используется обычный запрос NSURLConnection, ответ сервера сохраняем в NSData
    NSError* error;
    NSData *responseData = [NSURLConnection sendSynchronousRequest:request returningResponse:nil error:&error];
    if(responseData){
        NSError* error;
        NSDictionary *dict = [NSJSONSerialization JSONObjectWithData:responseData options:NSJSONReadingAllowFragments error:&error];
                
        NSString *errorMsg = [[dict objectForKey:@"error"] objectForKey:@"error_msg"];
        
        NSLog(@"Server response: %@ \nError: %@", dict, errorMsg);                
        if([errorMsg isEqualToString:@"Captcha needed"]){
            _hasCaptcha = YES;
            // Сохраняем параметры для капчи
            NSString *captcha_sid = [[dict objectForKey:@"error"] objectForKey:@"captcha_sid"];
            NSString *captcha_img = [[dict objectForKey:@"error"] objectForKey:@"captcha_img"];
            [[NSUserDefaults standardUserDefaults] setObject:captcha_img forKey:@"captcha_img"];
            [[NSUserDefaults standardUserDefaults] setObject:captcha_sid forKey:@"captcha_sid"];            
            [[NSUserDefaults standardUserDefaults] setObject:reqURl forKey:@"request"];
            [[NSUserDefaults standardUserDefaults] synchronize];
        }
        else
        {
            if(errorMsg)
            {
                VkontakteLoginViewController* loginView = [[VkontakteLoginViewController alloc] init];
                _shouldCleanCaptured = NO;
                [self presentViewController:loginView animated:YES completion:nil];
            }
        }
        
        return dict;
    }
    
    return nil;
}

-(void)scrollViewDidScroll:(UIScrollView *)scrollView
{
    [self.textView setNeedsDisplay];
}
-(void)addImage:(UIImage *)image
{
    [self.shareImages addObject:image];
}
-(void)addLink:(NSString*)link
{
    self.shareLink = link;
}
@end
